<template>
	<div class="users">
  <user-layout></user-layout>
    <header-top>Users</header-top>
    <div class="container is-fluid">
      <div class="actions">
       <div class="level">
        <div class="level-left">
          <span class="level-item">
            <button @click="modalShow = true" class="button is-primary">Add User</button>
            <button @click="importUsersModalShow = true" class="button is-primary">Import Users</button>
          </span>
        </div>
        <div class="level-right">
         <input v-model="userFilter" type="text" class="input" placeholder="username">
       </div>
     </div>
   </div>

<users-table :users="usersFiltered" v-on:deleteUser="test"></users-table>


<modal v-if="modalShow" v-on:close="modalShow = flase" v-on:save="addUser">
 <label class="label">Name</label>
 <div class="level">
  <span class="level-item">
   <input class="input" type="text" placeholder="First Name" v-model="user.name.first">
 </span>
 <span class="level-item">
   <input class="input" type="text" placeholder="Last Name" v-model="user.name.last">
 </span>
</div>


<label class="label">Username</label>
<p class="control">
  <input class="input" type="text" placeholder="Username" v-model="user.username">
</p>
<label class="label">Email</label>
<p class="control">
  <input class="input" type="email" placeholder="user@example.org" v-model="user.email">
</p>
<label class="label">Password</label>
<p class="control">
  <input class="input" type="password" placeholder="●●●●●●●" v-model="user.password">
</p>
<label class="label">Confirm Password</label>
<p class="control">
  <input class="input" type="password" placeholder="●●●●●●●">
</p>
</modal>

<modal v-if="importUsersModalShow" v-on:close="importUsersModalShow = false" v-on:save="importUsers">
  <textarea v-model="importUsersJSON" class="textarea"></textarea>
</modal>


</div>
</div>
</template>

<script>
	import auth from '../../utils/auth'
	import user from '../../utils/user'
	import Modal from '../Utils/Modal'
  import HeaderTop from '../Utils/HeaderTop'
  import UsersTable from './UsersTable'
  import UserLayout from './UserLayout'
	// import ModalConfirm from './ModalConfirm'

	function userSchema() {
		return {
			userId: '',
			username: '',
			password: '',
			name: {
				first: '',
				last: ''
			},
			email: ''
		}
	}

	export default {
		name: 'user',
		components: {
			Modal,
      HeaderTop,
      UsersTable,
      UserLayout
			// ModalConfirm
		},
		data() {
			return {
					// User Schema
					user: userSchema(),
					// list of users
					users: [],
					// component state
					modalShow: false,
          importUsersModalShow: false,
          importUsersJSON: '',
          deleteConfirm: false,
          deleteId: '',
          userFilter: ''

        }
      },
      computed: {
        usersFiltered() {
          return this.users.filter((u) => { return u.username.toLowerCase().search(this.userFilter) != -1 })
        },

      },

      methods: {
        test(a) {
          console.log(a + 'sample')
        },

        addUser() {
         var newUser = this.user

         user.newUser(this, newUser)
         .then((user) => this.users.push(user))
         // .then((user) => this.usersFiltered.push(user))

         this.modalShow = false
         this.user = userSchema()
       },

       deleteUser(id) {
         // alert('delete ' + id)
         user.deleteUser(this, id)
         .then((res) => {
          if (res.result == "OK") {
           this.users = this.users.filter((v) => { return v.userId != id })
           this.deleteConfirm = false
         }
       })
       },

       importUsers() {
        let that = this
        let newUsers = JSON.parse(this.importUsersJSON)
        for (let i = 0; i <= newUsers.length - 1; i++) {
          user.newUser(that, newUsers[i])
          .then((user) => that.users.push(user))
        }

        this.importUsersModalShow = false
        // user.newUser(this, newUsers[0])
        //  .then((user) => this.users.push(user))
        // console.log(newUsers)

      },
    },
    mounted() {
      let self = this
      user.getAllUsers(this)
			// .then((res) => console.log(res))
			.then((users) => self.users = users)
			.catch((err) => console.error(err))

		}
	}
</script>

<style lang="scss">
	.users {
		img {
			width: 30px;
		}
		td {
			vertical-align: middle;
		}
		.deleteConfirm {
			text-align: right;
			cursor: pointer;
		}
	}

  .checkmark {
   display: inline-block;
   background-color: rgba(10, 10, 10, 0.1);
   height: 24px;
   width: 24px;
   border-radius: 50%;

 }
 .checkmark:after {
  content: '';
  display: block;
  position: absolute;
  margin-top: 5px;
  margin-left: 9px;


  width: 6px;
  height: 10px;

  border: solid #fff;
  border-width: 0 2px 2px 0;
  transform: rotate(45deg);

}

.checkmark-small {
  display: inline-block;
  background-color: rgba(10, 10, 10, 0.1);
  height: 16px;
  width: 16px;
  border-radius: 50%;
  margin-left: 7px;
}

.checkmark-small:hover {
  background-color: rgba(10, 10, 10, 0.2);
}

.checkmark-small:after {
  content: '';
  display: block;
  position: absolute;
  margin-top: 3px;
  margin-left: 6px;


  width: 5px;
  height: 8px;

  border: solid #fff;
  border-width: 0 2px 2px 0;
  transform: rotate(45deg);

}

</style>
